// interface.cpp : Defines the exported functions for the DLL application.
//

#include <stdio.h>
#include "interface.h"
#include <math.h>
#include <string.h>


USB_SPEC *spec_list=NULL;
unsigned int num_spec=0;
// This is an example of an exported function.
//USB_SPEC *current_usb_dev;
//char current_devnum;
//int integration_time=0;
SYSTEM_SETTING_TYPE data0;
SYSTEM_SETTING_STRING data1;
SYSTEM_SETTING_COEF data2, data6;
SYSTEM_SETTING_NAME data3;
SYSTEM_SETTING_TCP data4;
SYSTEM_LINEARITY_COEF data5;

void print_config_string(int len, unsigned int *data);
void del_all();
void append(USB_SPEC *ptr);
int calcrc(unsigned char *data, int len);
int calcrc(unsigned char *data, int len)
{
    unsigned short crc=0xFFFF;
    int i;
    for (i=0; i<len; i++)
    {
        crc = (crc >> 8) | (crc << 8);
        crc ^= data[i];
        crc ^= (unsigned char)(crc & 0xff) >> 4;
        crc ^= (crc << 8) << 4;
        crc ^= ((crc & 0xff) << 4) << 1;
    }
    data[i++]=crc>>8;
    data[i++]=(unsigned char) crc&0xff;
//	printf("crc %x %x %x\n", crc);
    return(i);
}
unsigned short calcrc1(unsigned char *data, int len);
unsigned short  calcrc1(unsigned char *data, int len)
{
    unsigned short crc=0xFFFF;
    int i;
    for (i=0; i<len; i++)
    {
        crc = (crc >> 8) | (crc << 8);
        crc ^= data[i];
        crc ^= (unsigned char)(crc & 0xff) >> 4;
        crc ^= (crc << 8) << 4;
        crc ^= ((crc & 0xff) << 4) << 1;
    }
    return(crc);
}
int scandata(unsigned char *data, int len);
// 92 is backlash \ , 13 and 92 are key words.
int scandata(unsigned char *data, int len)
{
    int i, size, newlen, len1;
    size=len-2;
    newlen=len;
    for(i=0; i<size; i++)
    {
        if(data[i]==92 || data[i]==13)
        {
            newlen++;
            for(len1=newlen; len1>i; len1--)
                data[len1]=data[len1-1];
            data[i]=92;
            i++;
            size++;
        }
    }
    return(newlen);
}
INTERFACE_API int XSPEC_setIntegrationTime(USB_SPEC *node, unsigned int time_us)
{
    unsigned char buffer[20];
    int wrotelen;
    int newlen;
    if(node->usb_dev==NULL)
        return (-1);
    buffer[0]=SET_ITIME_CMD;
    buffer[1]=(unsigned char) time_us>>24;
    buffer[2]=(unsigned char)((time_us>>16) & 0xff);
    buffer[3]=(unsigned char)((time_us>>8) & 0xff);
    buffer[4]=(unsigned char)(time_us & 0xff);
    buffer[5]=13;
    buffer[6]=13;
    buffer[7]=0;
    newlen=scandata(buffer, 7);
    buffer[newlen]=0;

    wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)buffer, newlen, TWO_SEC);
//return 0 on success, or TIMEOUT, return partial length, or ERROR
//	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);
}
INTERFACE_API int XSPEC_getIntegrationTime(USB_SPEC *node)
{
    int ret;
    if(node->usb_dev==NULL)
        return (-1);
    ret=XSPEC_get_SpecConfig(node);
    if(ret)
        return(ret);
    else
    {
        return(data0.integration_time);
    }
}
INTERFACE_API double XSPEC_get_temperature(unsigned int bits)
{
    unsigned int bits1, bits2;
    double temperature;
    bits2=bits;
    temperature=bits & 0xFFFF;
    bits1=bits>>31;
    bits=0x7FFF & (bits>>16);
    if(bits1)
    {
        unsigned int temp1, temp2;
        temp1=bits&0xff;
        temp2=bits2>>24;
        if(temp1==16 && temp2==0x80)
        {
            //adt7410
            if(bits2 & 0x8000)
                return((temperature-65536)/128.0);
            else
                return((temperature)/128.0);
        }
        else
        {
            double max;
            double volt;
            max=pow(2.0,(int)bits&0xff);
            volt=bits>>8;
            volt=volt/10;
            temperature=(double)temperature/max*volt;
            temperature=((temperature)-0.8)*1000.0/2.65+27.0;
        }
    }
    else
    {
        if(bits==0)
        {
            temperature=temperature/1023.0*3.3;
            temperature=((temperature/5.7)-0.3)*1000.0+25.0;
        }
        else
        {
            double max;
            double volt;
            max=pow(2.0,(int)bits&0xff);
            volt=bits>>8;
            volt=volt/10;
            temperature=(double)temperature/max*volt;
            temperature=((temperature/5.7)-0.3)*1000.0+25.0;
        }
    }
    return(temperature);
}
void print_config()
{
    double temperature;//0.3v at 25c, 5.7X amplification 3.3=1023
    unsigned int bits, bits1;
    printf("- indicate not implemented\n");
    printf("integration time: %d\n", data0.integration_time);
    printf("integration mode: %d\n", data0.int_mode);
    printf("Trigger mode: %d\n", data0.trig_mode);
    printf("-extern_trigger_delay: %d\n", data0.extern_trigger_delay);
    printf("Skip # of reading: %d\n", data0.st_skip);
    printf("-Dark Offset: %d\n", data0.dark_offset);
    printf("LAMP PWN SETTING 0: 0x%X\n", data0.LAMP_PWM0);
    printf("LAMP PWM SETTING 1: 0x%X\n", data0.LAMP_PWM1);
    printf("Read # times: %d\n", data0.multiple_count);
    printf("LAMP Mode. 1==sync: 0x%X\n", data0.lamp_mode);
    printf("Port Direction 0==input, 1==output: 0x%X\n", data0.dir_port);
    printf("Port Reading:  0x%X\n", data0.port);


    temperature=XSPEC_get_temperature(data0.temp);
    printf("ADC temperature: %d %lf \n", data0.temp, temperature);
    printf("Flash Size:  0x%X\n", data0.flash_size);
    printf("Flash Page Size:  0x%X\n", data0.flash_page_size);
    printf("Flash setting_start:  0x%X\n", data0.flash_setting_start);
    printf("Flash start_auto_adj_dc_bias:  0x%X\n", data0.start_auto_adj_dc_bias);
    printf("Average:  0x%X\n", data0.average);

    printf("Number of Pixels: %d\n", data1.pixels);
    printf("Description:");
    print_config_string(4, data1.description);
    printf("Firmware Version:");
    print_config_string(4, data1.firmware_version);
    printf("Serial:");
    print_config_string(4, data1.serial);
    printf("Detector:");
    print_config_string(4, data1.detector);
    printf("Grating:");
    print_config_string(4, data1.grating);
    printf("Entrance Filter:");
    print_config_string(4, data1.entrance_filter);
    printf("Slit Size:");
    print_config_string(4, data1.slit_size);
    printf("Sorting Filter:");
    print_config_string(4, data1.sorting_filter);

    printf("Start Wavelength %lf\n", data2.wave_start);
    printf("End Wavelength %lf\n", data2.wave_end);
    printf("User Coef: \n");
    for(int i=0; i<6; i++)printf("\t%lf \n", data2.user_coef[i]);
    printf("Factory Coef: \n");
    for(int i=0; i<6; i++)printf("\t%lf \n", data2.system_coef[i]);
    printf("BIAS PWM SETTING: 0x%X\n", data2.BIAS_PWM);
    printf("Calibration Coef order: %d\n", data2.coef_order);
    printf("Dark Start Pixel: %d\n", data2.dark_start);
    printf("Dark End Pixel: %d\n", data2.dark_end);
    printf("Data Start Pixel: %d\n", data2.data_start);
    printf("Data End Pixel: %d\n", data2.data_end);

    printf("User String: ");
    print_config_string(16, data3.user_name);
    printf("Compiled Date String: ");
    print_config_string(8, data3.date_string);
    printf("Compiled Time String: ");
    print_config_string(8, data3.time_string);

    printf("Ethernet Settings: ");
    printf("mac: %2x:%2x:%2x:%2x:%2x:%2x\n", data4.mac[0], data4.mac[1], data4.mac[2], data4.mac[3], data4.mac[4], data4.mac[5]);
    printf("IP: %d.%d.%d.%d\n", data4.ip[0], data4.ip[1],data4.ip[2],data4.ip[3]);
    printf("Gateway: %d.%d.%d.%d\n", data4.gate[0], data4.gate[1],data4.gate[2],data4.gate[3]);
    printf("Mask: %d.%d.%d.%d\n", data4.mask[0], data4.mask[1],data4.mask[2],data4.mask[3]);
    printf("Tcp Port: %d\n", data4.tcp_port);
    printf("Http Port: %d\n", data4.http_port);
    printf("Use this setting or default: %d\n", data4.use_this);
    printf("default: 12.34.56.78.9a.bc, 100.0.0.100, 100.0.0.1, 255.255.255.0, 8888, 80 ");
}
INTERFACE_API int XSPEC_print_config(USB_SPEC *node)
{
    int ret;
    if(node->usb_dev==NULL)
        return (-1);
    ret=XSPEC_get_SpecConfig(node);
    if(ret)
    {
        printf("get_SpecConfig error\n");
        return(ret);
    }
    else
    {
        print_config();
    }
    return(0);
}
void print_config_string(int len, unsigned int *data)
{
    char *ptr;
    int length;
    length=len*4;
    ptr=(char *)data;
    for(int i=0; i<length; i++)
    {
        if(ptr[i])
            printf("%c", ptr[i]);
        else
        {
            printf("\n");
            return;
        }
    }
    printf("\n");
}

//set sync mode for flash lamp, pass in 1 or 0, 1 to enable, 0 to disable. 
INTERFACE_API int XSPEC_flash_Sync(USB_SPEC *node, unsigned char val)
{
    SYSTEM_SETTING_TYPE data0;
    int ret;
    ret=XSPEC_get_SpecConfig0123(node,(char *) &data0, 0);
    if(ret)
        return(ret);
	if(val)
    	data0.lamp_mode|=1;
	else
		data0.lamp_mode&=(~1);
    ret=XSPEC_write_SpecConfig(node, (char *)&data0, 0);
    return(ret);
}

INTERFACE_API int XSPEC_get_SpecConfig0123(USB_SPEC *node, char *p_data, int index)
{
    int ret;
    char *ptr;
    if(node->usb_dev==NULL)
        return (-1);
    ret=XSPEC_get_SpecConfig(node);
    if(ret)
        return(ret);
    if(index==0)
        ptr=(char *)&data0;
    else if(index==1)
        ptr=(char *)&data1;
    else if(index==2)
        ptr=(char *)&data2;
    else if(index==3)
        ptr=(char *)&data3;
    else if(index==4)
        ptr=(char *)&data4;
    memcpy((char *)p_data, (char *)ptr, FLASH_PAGE_SIZE);
    return(0);
}
INTERFACE_API int XSPEC_upgrade(USB_SPEC *node)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=UPGRADE_CMD;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;

    newlen=scandata(write_buffer, 3);
    write_buffer[newlen]=0;


    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_get_SpecProg(USB_SPEC *node, unsigned short page)
{
    unsigned char write_buffer[10];
    int newlen;
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=READ_NVMEM_PRG;
    write_buffer[1]=page>>8;
    write_buffer[2]=page&0xff;;
    write_buffer[3]=1;
    write_buffer[4]=13;
    write_buffer[5]=13;
    write_buffer[6]=0;


    newlen=scandata(write_buffer, 6);
    write_buffer[newlen]=0;


    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);
}
INTERFACE_API int XSPEC_update_config_mem(USB_SPEC *node, char *p_data)
{
    int i, newlen;
    char *int_ptr;
    char write_buffer[FLASH_PAGE_SIZE*2];
    int wrotelen;

    if(node->usb_dev==NULL)
        return (-1);


    write_buffer[0]=WRITE_SETTING_CMD;
    write_buffer[1]=(char) 0;
    write_buffer[2]=(char)1;
    write_buffer[3]=1;   //not used. for alignment
//	temp=(char *)temp_int;
//	for(i=0;i<FLASH_PAGE_SIZE;i++)
//		temp[i]=src[i];

    int_ptr=(char *)&(write_buffer[4]);

    for(i=0; i<FLASH_PAGE_SIZE; i++)
        int_ptr[i]=p_data[i];

    write_buffer[132]=13;
    write_buffer[133]=13;
    write_buffer[134]=0;

    newlen=scandata((unsigned char *)write_buffer, 134);
    write_buffer[newlen]=0;

    wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_write_SpecProg(USB_SPEC *node, char *p_data, unsigned int page_size, int index)
{
    int i, newlen;
    char *int_ptr;
    int ret;
    char write_buffer[FLASH_PAGE_SIZE*3];
    int page;
    int wrotelen;
    if(node->usb_dev==NULL)
        return (-1);
    if(index<0 )  //check the upper bound in the app.
        return(-1);



    write_buffer[0]=WRITE_PROG_CMD;
    page=index;
    i=page>>8;
    write_buffer[1]=(char) i;
    i=page & 0xFF;
    write_buffer[2]=(char)i;
    if(page_size==128)
        write_buffer[3]=1;   //page_size factor x128.
    else if(page_size==256)
        write_buffer[3]=2;
    //src=(char *)&(p_data);
//	temp=(char *)temp_int;
//	for(i=0;i<FLASH_PAGE_SIZE;i++)
    //	temp[i]=src[i];

    int_ptr=(char  *)&(write_buffer[4]);

    for(i=0; i<page_size; i++)
        int_ptr[i]=p_data[i];

    write_buffer[page_size+4]=13;
    write_buffer[page_size+5]=13;
    write_buffer[page_size+6]=0;

    newlen=scandata((unsigned char *)write_buffer, page_size+6);
    write_buffer[newlen]=0;
    wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}


INTERFACE_API int XSPEC_write_SpecConfig(USB_SPEC *node, char *p_data, int index)
{
    int i, newlen;
    char *int_ptr;
    int ret;
    char write_buffer[FLASH_PAGE_SIZE*2];
    int page;
    int wrotelen;
    if(node->usb_dev==NULL)
        return (-1);
    if(index<0 || index>6)
        return(-1);



    write_buffer[0]=WRITE_NVMEM_CMD;
    page=index;
    i=page>>8;
    write_buffer[1]=(char) i;
    i=page & 0xFF;
    write_buffer[2]=(char)i;
    write_buffer[3]=1;   //not used. for alignment
    //src=(char *)&(p_data);
//	temp=(char *)temp_int;
//	for(i=0;i<FLASH_PAGE_SIZE;i++)
    //	temp[i]=src[i];

    int_ptr=(char  *)&(write_buffer[4]);

    for(i=0; i<FLASH_PAGE_SIZE; i++)
        int_ptr[i]=p_data[i];

    write_buffer[132]=13;
    write_buffer[133]=13;
    write_buffer[134]=0;

    newlen=scandata((unsigned char *)write_buffer, 134);
    write_buffer[newlen]=0;

    wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_measure(USB_SPEC *node, unsigned short *data_array, unsigned int id, unsigned int integ_time)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=TRIG_CMD;
    write_buffer[1]=(unsigned char)id;
    id=id>>8;
    write_buffer[2]=(unsigned char)id;
    id=id>>8;
    write_buffer[3]=(unsigned char)id;
    id=id>>8;
    write_buffer[4]=(unsigned char)id;
    write_buffer[5]=13;
    write_buffer[6]=13;
    write_buffer[7]=0;

    newlen=scandata(write_buffer, 7);
    write_buffer[newlen]=0;
	printf("write measure\n");
    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
	printf("waiting for data....................\n");
    bytesread=usb_bulk_read(node->usb_dev, EP_IN, (char *)data_array, BUF_SIZE, integ_time/1000+TWO_SEC);
	printf("write bytesread=%d\n", bytesread);
    return(bytesread);
}

// for async implementation, please check with
// http://libusb.sourceforge.net/api-1.0/group__asyncio.html

INTERFACE_API int XSPEC_measure_async(USB_SPEC *node, unsigned int id)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=TRIG_CMD;
    write_buffer[1]=(unsigned char)id;
    id=id>>8;
    write_buffer[2]=(unsigned char)id;
    id=id>>8;
    write_buffer[3]=(unsigned char)id;
    id=id>>8;
    write_buffer[4]=(unsigned char)id;
    write_buffer[5]=13;
    write_buffer[6]=13;
    write_buffer[7]=0;

    newlen=scandata(write_buffer, 7);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_measure_stop(USB_SPEC *node)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=ABORT_CMD;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;

    newlen=scandata(write_buffer, 3);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_adjust_bias(USB_SPEC *node)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=ADJUST_BIAS_CMD;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;

    newlen=scandata(write_buffer, 3);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_reset(USB_SPEC *node)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=USB_RESET;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;

    newlen=scandata(write_buffer, 3);
    write_buffer[newlen]=0;
//	usb_reset(node->usb_dev);

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}
INTERFACE_API int XSPEC_pwm_start(USB_SPEC *node, int which)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);

    write_buffer[0]=START_PWM_CMD;
    write_buffer[1]=which;
    write_buffer[2]=13;
    write_buffer[3]=13;
    write_buffer[4]=0;

    newlen=scandata(write_buffer, 4);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}

INTERFACE_API int XSPEC_pwm_stop(USB_SPEC *node, int which)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=END_PWM_CMD;
    write_buffer[1]=which;
    write_buffer[2]=13;
    write_buffer[3]=13;
    write_buffer[4]=0;

    newlen=scandata(write_buffer, 4);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}


INTERFACE_API int XSPEC_continous_measure_async(USB_SPEC *node, unsigned int id)
{
    int bytesread=0, newlen;
    unsigned char write_buffer[FLASH_PAGE_SIZE];
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=TRIG_CMD_REPEAT;
    write_buffer[1]=(unsigned char)id;
    id=id>>8;
    write_buffer[2]=(unsigned char)id;
    id=id>>8;
    write_buffer[3]=(unsigned char)id;
    id=id>>8;
    write_buffer[4]=(unsigned char)id;
    write_buffer[5]=13;
    write_buffer[6]=13;
    write_buffer[7]=0;

    newlen=scandata(write_buffer, 7);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}
INTERFACE_API int XSPEC_continous_wait(USB_SPEC *node, unsigned short *data_array,unsigned int integration_time)
{
    if(node->usb_dev==NULL)
        return (-1);

    int bytesread=usb_bulk_read(node->usb_dev, EP_IN, (char *)data_array, BUF_SIZE, integration_time/1000+1000L);
    return(bytesread);

#if 0
    usb_bulk_setup_async(node->usb_dev, &(node->context0), EP_IN);
    usb_submit_async(node->context0, (char *)data_array, BUF_SIZE);
    int bytesread=usb_reap_async(node->context0, 1000L+integration_time/1000);
//   if(bytesread<0 && bytesread!=ETRANSFER_TIMEDOUT)
    usb_free_async(&(node->context0));
    return(bytesread);
#endif
}
INTERFACE_API int XSPEC_get_SpecConfig_async(USB_SPEC *node)
{
    unsigned char write_buffer[10];
    int newlen;
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=READ_NVMEM_CMD;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;


    newlen=scandata(write_buffer, 3);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805
    return(wrotelen);

}
INTERFACE_API int XSPEC_get_SpecConfig(USB_SPEC *node)
{
    unsigned char data_buffer[FLASH_PAGE_SIZE*10];
    int newlen, index;
    unsigned short *buffer, *data, type, size;
    unsigned char write_buffer[10];
    int ret;
    if(node->usb_dev==NULL)
        return (-1);
    write_buffer[0]=READ_NVMEM_CMD;
    write_buffer[1]=13;
    write_buffer[2]=13;
    write_buffer[3]=0;
    newlen=scandata((unsigned char *)write_buffer, 3);
    write_buffer[newlen]=0;

    int wrotelen=usb_bulk_write(node->usb_dev, EP_OUT, (char *)write_buffer, newlen, TWO_SEC);
    //return 0 on success, or TIMEOUT, return partial length, or ERROR
    //	http://libusb.sourceforge.net/api-1.0/group__syncio.html#gab8ae853ab492c22d707241dc26c8a805


    int bytesread=usb_bulk_read(node->usb_dev, EP_IN, (char *)data_buffer, sizeof(data_buffer), TWO_SEC);

#if 0
    usb_bulk_setup_async(node->usb_dev, &(node->context1), EP_OUT);
    usb_submit_async(node->context1, (char *)write_buffer, newlen);
    int wrotelen=usb_reap_async(node->context1, INFINITE);
    usb_free_async(&(node->context1));

    usb_bulk_setup_async(node->usb_dev, &(node->context0), EP_IN);
    usb_submit_async(node->context0, (char *)data_buffer, sizeof(data_buffer));
    int bytesread=usb_reap_async(node->context0, 1000L);
    usb_free_async(&(node->context0));
#endif
    buffer=(unsigned short *) data_buffer;

    index=0;
    if(buffer[index++]!=PACKET_START)
    {
        return(-1);
    }

//	crc=PACKET_START;
    type=buffer[index++];
//	crc^=type;
    if(type==READ_NVMEM_CMD)
    {
        SYSTEM_SETTING_TYPE setting0;
        SYSTEM_SETTING_STRING setting1;
        SYSTEM_SETTING_COEF setting2, setting6;
        SYSTEM_SETTING_NAME setting3;
        SYSTEM_SETTING_TCP setting4;
        SYSTEM_LINEARITY_COEF setting5;
        size=buffer[index++];
        //	crc^=size;
        data=(unsigned short *) &setting0; //&(node_ptr->setting0);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        data=(unsigned short *) &setting1; //&(node_ptr->setting1);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        data=(unsigned short *) &setting2; //&(node_ptr->setting2);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        data=(unsigned short *) &setting3; //&(node_ptr->setting3);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        data=(unsigned short *) &setting4; //&(node_ptr->setting3);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        data=(unsigned short *) &setting5; //&(node_ptr->setting3);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2&& index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }
        if(index>=bytesread)
            data=(unsigned short *) &setting6; //&(node_ptr->setting3);
        for(int tmp=0; tmp<FLASH_PAGE_SIZE/2 && index<bytesread; tmp++)
        {
            data[tmp]=buffer[index++];
            //		crc^=data[tmp];
        }

        //	if(crc!=buffer[index++])
        //	{
        //		return (-1);
        //	}
        memcpy((char *)&(data0), (char *)&setting0, sizeof(SYSTEM_SETTING_TYPE));
        memcpy((char *)&(data1), (char *)&setting1, sizeof(SYSTEM_SETTING_STRING));
        memcpy((char *)&(data2), (char *)&setting2, sizeof(SYSTEM_SETTING_COEF));
        memcpy((char *)&(data3), (char *)&setting3, sizeof(SYSTEM_SETTING_NAME));
        memcpy((char *)&(data4), (char *)&setting4, sizeof(SYSTEM_SETTING_TCP));
        memcpy((char *)&(data5), (char *)&setting5, sizeof(SYSTEM_LINEARITY_COEF));
        memcpy((char *)&(data6), (char *)&setting6, sizeof(SYSTEM_SETTING_COEF));
        return(0);
    }
    else
        return(-1);

}
INTERFACE_API int XSPEC_scan_usb_for_spec(void)
{
    int ret;
    char description[256];
    char string[256];
    struct usb_bus *bus;
    struct usb_device *dev;
    usb_dev_handle *usb_dev=NULL;
    XSPEC_usb_cleanup();
    usb_init(); /* initialize the library */
    usb_find_busses(); /* find all busses */
    usb_find_devices(); /* find all connected devices */
    for(bus = usb_get_busses(); bus; bus = bus->next)
    {
        for(dev = bus->devices; dev; dev = dev->next)
        {
            if(dev->descriptor.idVendor == MY_VID && (dev->descriptor.idProduct == MY_PID || dev->descriptor.idProduct == MY_NEW_PID))
            {
                USB_SPEC *newnode=new USB_SPEC;

                usb_dev=usb_open(dev);
                if (usb_dev)
                {
                    if (dev->descriptor.iManufacturer)
                    {
                        ret = usb_get_string_simple(usb_dev, dev->descriptor.iManufacturer, string, sizeof(string));
                        if (ret > 0)
                            snprintf(description, sizeof(description), "%s - ", string);
                        else
                            snprintf(description, sizeof(description), "%04X - ",
                                     dev->descriptor.idVendor);
                    }
                    else
                        snprintf(description, sizeof(description), "%04X - ",
                                 dev->descriptor.idVendor);

                    if (dev->descriptor.iProduct)
                    {
                        ret = usb_get_string_simple(usb_dev, dev->descriptor.iProduct, string, sizeof(string));
                        if (ret > 0)
                            snprintf(description + strlen(description), sizeof(description) -
                                     strlen(description), "%s", string);
                        else
                            snprintf(description + strlen(description), sizeof(description) -
                                     strlen(description), "%04X", dev->descriptor.idProduct);
                    }
                    else
                        snprintf(description + strlen(description), sizeof(description) -
                                 strlen(description), "%04X", dev->descriptor.idProduct);
                    if (dev->descriptor.iSerialNumber)
                    {
                        ret = usb_get_string_simple(usb_dev, dev->descriptor.iSerialNumber, string, sizeof(string));
                        if (ret > 0)
                            snprintf(description + strlen(description), sizeof(description) -
                                     strlen(description), " %s", string);
                        else
                            snprintf(description + strlen(description), sizeof(description) -
                                     strlen(description), " %04X", dev->descriptor.idProduct);

                    }
                }
                else
                    snprintf(description, sizeof(description), "%04X - %04X",
                             dev->descriptor.idVendor, dev->descriptor.idProduct);




                if (usb_dev)
                    usb_close(usb_dev);


                strcpy(newnode->filename, description);
                newnode->devnum=dev->devnum;
                newnode->next=NULL;
                append(newnode);
                num_spec++;
            }
        }
    }
    return(num_spec);

}
INTERFACE_API void XSPEC_usb_cleanup(void)
{
    del_all();

//  current_devnum=-1;
// current_usb_dev=NULL;
}
INTERFACE_API int XSPEC_getNumConnectedSpectrometers(void)
{
    return(num_spec);
}
INTERFACE_API int XSPEC_get_Spec(unsigned int index, USB_SPEC *node)
{
    USB_SPEC *ptr;
    ptr=spec_list;
    if(index>=num_spec) return (-1);
    for(unsigned int i=0; i<index; i++)
        ptr=ptr->next;
    memcpy((char *)node, (char *)ptr, sizeof(USB_SPEC));
    return(0);

}
INTERFACE_API void XSPEC_print_Spec()
{
    USB_SPEC *ptr;
    int index=0;
    ptr=spec_list;
    while(ptr)
    {
        printf("Index %d:\n", index);
        printf("\tUSB Filename: %s\n", ptr->filename);
        printf("\tUSB device Number: %d\n", ptr->devnum);
        printf("\tUSB device Handle: %p\n", ptr->usb_dev);

        ptr=ptr->next;
        index++;
    }

}
INTERFACE_API usb_dev_handle *XSPEC_open_Spec(char devnum)
{
    struct usb_bus *bus;
    struct usb_device *dev;
    usb_dev_handle *usb_dev=NULL;
    int ret;

    usb_init(); /* initialize the library */
    usb_find_busses(); /* find all busses */
    usb_find_devices(); /* find all connected devices */
    for(bus = usb_get_busses(); bus; bus = bus->next)
    {
        for(dev = bus->devices; dev; dev = dev->next)
        {
            if(dev->devnum == devnum)
            {
                usb_dev=usb_open(dev);
                if(usb_dev)
                {
                #if 0
				//don't call this function. It is already configured because there is only one. 
				// it can screw up the state. 
                    ret=usb_set_configuration(usb_dev, 1);
                    if(ret < 0)
                    {
                        usb_close(usb_dev);
                        printf("usb_set_configuration error ret=%d\n", ret);
                        usb_dev=(usb_dev_handle *)-1;
                        return(usb_dev);
                    }

					#endif
                    ret=usb_claim_interface(usb_dev, 0);
                    if(ret < 0)
                    {
                        usb_close(usb_dev);
                        printf("usb_claim_interface error ret=%d\n", ret);
                        usb_dev=(usb_dev_handle *)-1;
                        return(usb_dev);
                    }

                }
                return(usb_dev);



            }
        }
    }

    usb_dev=(usb_dev_handle *)-1;
    return(usb_dev);


}
INTERFACE_API int XSPEC_close_Spec(USB_SPEC *node)
{
    if(node->usb_dev && node->usb_dev!=(usb_dev_handle *)-1)
    {
        usb_release_interface(node->usb_dev, 0);
        usb_close(node->usb_dev);
        node->usb_dev=NULL;
    }
    return(0);

}


void del_all()
{
    USB_SPEC *ptr, *ptr1;
    ptr=spec_list;
    if(ptr==NULL)
        return;

    while(ptr)
    {
        ptr1=ptr->next;

        delete ptr;
        ptr=ptr1;
    }
    spec_list=NULL;
    num_spec=0;
}

void append(USB_SPEC *ptr)
{
    USB_SPEC *node;
    if(spec_list==NULL)
    {
        spec_list=ptr;
        return;
    }
    node=spec_list;
    while(node->next)
    {
        node=node->next;
    }
    node->next=ptr;
}




/*
INTERFACE_API int setChannel(char devnum)
{
	USB_SPEC *ptr;
	ptr=spec_list;
	while(ptr)
	{
		if(ptr->devnum==devnum)
		{
			current_usb_dev=ptr;
			current_devnum=devnum;
			return (0);
		}
	}
	return(-1);

}

INTERFACE_API char getChannel(void)
{
	return(current_devnum);
}
*/





